module System

  def self.process_alive?(pid, verbose: true)
    begin
      Process.kill(0, pid)
      return true
    rescue Errno::EPERM                     # changed uid
      puts "No permission to query #{pid}!" if verbose
    rescue Errno::ESRCH
      puts "#{pid} is NOT running." if verbose      # or zombied
    rescue
      puts "Unable to determine status for #{pid} : #{$!}" if verbose
    end
    return false
  end

  def self.stop_process(pid)
    Process.kill('INT', pid)
    while process_alive?(pid, verbose: CLI_OPTS[:verbose])
      print "."
      sleep 0.3
    end
  end
end